*** How Does the Dramatic Rise of CPS Nonresponse Impact Labor Market Indicators? 
*** Bernhardt, Munro, Wolcott 
*** Journal of Applied Econometrics 
*** 2023 

*** CPS_Extract.do 
*** Extracts Useful Variables from NBER CPS .raw files Jan. 1994-July 2021 
*** Based Heavily on code by Robert Shimer 
*** Key Outputs: files cpsb199401.dta through cpsb202107.dta 

local x = 199401

while `x' <=199505 { 
clear
infix double gestfips 93-94 double PREMP 480-481 double PRSJMJ 496-497 double hrhhid 1-12 str hrsersuf 75-76 line 147-148 mis 63-64 age 122-123 race 139-140 sex 129-130 status 180-181 str dur 407-409 double fweight 613-622 double lweight 593-602 llind 69-70 educ 137-138 mar 125-126 str ind 436-438 str occu 439-441 /// 
double HRINTSTA 57-58 HUTYPEA 41-42 HUTYPEB 43-44 HUTYPEC 45-46 double HUINTTYP 65-66 double LFPROXY 178-179 double employ_type 432-433 double non_farm 460-461 str HRSAMPLE 71-74 double HRSAMPLE_num 72-73 HUHHNUM 77-78 ind_recode 482-483 occu_recode 486-487 HETENURE 29-30 fam_income 39-40 gemsa 97-100 double PEHSPNON 157-158 PELKLWO 340-341 ///
using Data/cpsb`x'.raw

replace hrsersuf="0" if hrsersuf=="-1"
replace hrsersuf="1" if hrsersuf=="A"
replace hrsersuf="2" if hrsersuf=="B"
replace hrsersuf="3" if hrsersuf=="C"
replace hrsersuf="4" if hrsersuf=="D"
replace hrsersuf="5" if hrsersuf=="E"
replace hrsersuf="6" if hrsersuf=="F"
replace hrsersuf="7" if hrsersuf=="G"
replace hrsersuf="8" if hrsersuf=="H"
replace hrsersuf="9" if hrsersuf=="I"
replace hrsersuf="10" if hrsersuf=="J"
replace hrsersuf="11" if hrsersuf=="K"
replace hrsersuf="12" if hrsersuf=="L"
replace hrsersuf="13" if hrsersuf=="M"
replace hrsersuf="14" if hrsersuf=="N"
replace hrsersuf="15" if hrsersuf=="O"
replace hrsersuf="16" if hrsersuf=="P"
replace hrsersuf="17" if hrsersuf=="Q"
replace hrsersuf="18" if hrsersuf=="R"
replace hrsersuf="19" if hrsersuf=="S"
replace hrsersuf="20" if hrsersuf=="T"
replace hrsersuf="21" if hrsersuf=="U"
replace hrsersuf="22" if hrsersuf=="V"
replace hrsersuf="23" if hrsersuf=="W"
replace hrsersuf="24" if hrsersuf=="X"
replace hrsersuf="25" if hrsersuf=="Y"
replace hrsersuf="26" if hrsersuf=="Z" // changed X and Z to the more intuitive version
destring hrsersuf, replace

gen hrhhid2 = HRSAMPLE_num * 1000 + hrsersuf * 10 + HUHHNUM
gen double hhid_unique = hrhhid * 100000 + hrhhid2 
drop HRSAMPLE HRSAMPLE_num hrsersuf HUHHNUM 

replace dur="." if dur=="--"
replace ind="." if ind=="---"
replace occu="." if occu=="---"

drop if age>=0 & age<16 // dropping individuals not old enough to be in the labor force but keeping -1 missing observations

replace gemsa = 1 if gemsa > 0 
rename gemsa metropolitan

compress
save Data/cpsb`x'.dta, replace

local x = `x' + 1
if (`x'-13)/100 == int((`x'-13)/100) {
    local x = `x' + 88
    }
}

* 

while `x' <=199712 {
clear
infix double gestfips 93-94 double hrhhid 1-15 double PRSJMJ 496-497 double PREMP 480-481 str hrsersuf 75-76 line 147-148 mis 63-64 age 122-123 race 139-140 sex 129-130 status 180-181 str dur 407-409 double fweight 613-622 double lweight 593-602 llind 69-70 educ 137-138 mar 125-126 str ind 436-438 str occu 439-441 /// 
	double HRINTSTA 57-58 HUTYPEA 41-42 HUTYPEB 43-44 HUTYPEC 45-46 double HUINTTYP 65-66 double LFPROXY 178-179 double employ_type 432-433 double non_farm 460-461 str HRSAMPLE 71-74 double HRSAMPLE_num 72-73 HUHHNUM 77-78 ind_recode 482-483 occu_recode 486-487 HETENURE 29-30 fam_income 39-40 gemsa 97-100 double PEHSPNON 157-158 PELKLWO 340-341 ///
using Data/cpsb`x'.raw

replace hrsersuf="0" if hrsersuf=="-1"
replace hrsersuf="1" if hrsersuf=="A"
replace hrsersuf="2" if hrsersuf=="B"
replace hrsersuf="3" if hrsersuf=="C"
replace hrsersuf="4" if hrsersuf=="D"
replace hrsersuf="5" if hrsersuf=="E"
replace hrsersuf="6" if hrsersuf=="F"
replace hrsersuf="7" if hrsersuf=="G"
replace hrsersuf="8" if hrsersuf=="H"
replace hrsersuf="9" if hrsersuf=="I"
replace hrsersuf="10" if hrsersuf=="J"
replace hrsersuf="11" if hrsersuf=="K"
replace hrsersuf="12" if hrsersuf=="L"
replace hrsersuf="13" if hrsersuf=="M"
replace hrsersuf="14" if hrsersuf=="N"
replace hrsersuf="15" if hrsersuf=="O"
replace hrsersuf="16" if hrsersuf=="P"
replace hrsersuf="17" if hrsersuf=="Q"
replace hrsersuf="18" if hrsersuf=="R"
replace hrsersuf="19" if hrsersuf=="S"
replace hrsersuf="20" if hrsersuf=="T"
replace hrsersuf="21" if hrsersuf=="U"
replace hrsersuf="22" if hrsersuf=="V"
replace hrsersuf="23" if hrsersuf=="W"
replace hrsersuf="24" if hrsersuf=="X"
replace hrsersuf="25" if hrsersuf=="Y"
replace hrsersuf="26" if hrsersuf=="Z" // changed X and Z to the more intuitive version
destring hrsersuf, replace

gen hrhhid2 = HRSAMPLE_num * 1000 + hrsersuf * 10 + HUHHNUM
gen hhid_unique = hrhhid * 100000 + hrhhid2 
drop HRSAMPLE HRSAMPLE_num hrsersuf HUHHNUM 

replace dur="." if dur=="--"
replace ind="." if ind=="---"
replace occu="." if occu=="---"

drop if age>=0 & age<16 // dropping individuals not old enough to be in the labor force but keeping -1 missing observations

replace gemsa = 1 if gemsa > 0 
rename gemsa metropolitan

compress
save Data/cpsb`x'.dta, replace

local x = `x' + 1
if (`x'-13)/100 == int((`x'-13)/100) {
    local x = `x' + 88
    }
}

*

while `x' <=200212 {
clear
infix double gestfips 93-94 double hrhhid 1-15 double PRSJMJ 496-497 double PREMP 480-481 str hrsersuf 75-76 line 147-148 mis 63-64 age 122-123 race 139-140 sex 129-130 status 180-181 str dur 407-409 double fweight 613-622 double lweight 593-602 llind 69-70 educ 137-138 mar 125-126 str ind 436-438 str occu 439-441 /// 
	double HRINTSTA 57-58 HUTYPEA 41-42 HUTYPEB 43-44 HUTYPEC 45-46 double HUINTTYP 65-66 double LFPROXY 178-179 double employ_type 432-433 double non_farm 460-461 str HRSAMPLE 71-74 double HRSAMPLE_num 72-73 HUHHNUM 77-78 double PWCMPWGT 846-855 county 101-103 ind_recode 482-483 occu_recode 486-487 HETENURE 29-30 fam_income 39-40 gemsa 97-100 double PEHSPNON 157-158 PELKLWO 340-341 ///
using Data/cpsb`x'.raw

replace hrsersuf="0" if hrsersuf=="-1"
replace hrsersuf="1" if hrsersuf=="A"
replace hrsersuf="2" if hrsersuf=="B"
replace hrsersuf="3" if hrsersuf=="C"
replace hrsersuf="4" if hrsersuf=="D"
replace hrsersuf="5" if hrsersuf=="E"
replace hrsersuf="6" if hrsersuf=="F"
replace hrsersuf="7" if hrsersuf=="G"
replace hrsersuf="8" if hrsersuf=="H"
replace hrsersuf="9" if hrsersuf=="I"
replace hrsersuf="10" if hrsersuf=="J"
replace hrsersuf="11" if hrsersuf=="K"
replace hrsersuf="12" if hrsersuf=="L"
replace hrsersuf="13" if hrsersuf=="M"
replace hrsersuf="14" if hrsersuf=="N"
replace hrsersuf="15" if hrsersuf=="O"
replace hrsersuf="16" if hrsersuf=="P"
replace hrsersuf="17" if hrsersuf=="Q"
replace hrsersuf="18" if hrsersuf=="R"
replace hrsersuf="19" if hrsersuf=="S"
replace hrsersuf="20" if hrsersuf=="T"
replace hrsersuf="21" if hrsersuf=="U"
replace hrsersuf="22" if hrsersuf=="V"
replace hrsersuf="23" if hrsersuf=="W"
replace hrsersuf="24" if hrsersuf=="X"
replace hrsersuf="25" if hrsersuf=="Y"
replace hrsersuf="26" if hrsersuf=="Z" // changed X and Z to the more intuitive version
destring hrsersuf, replace

gen hrhhid2 = HRSAMPLE_num * 1000 + hrsersuf * 10 + HUHHNUM
gen hhid_unique = hrhhid * 100000 + hrhhid2 
drop HRSAMPLE HRSAMPLE_num hrsersuf HUHHNUM 

gen county1 = gestfips * 1000 + county 

replace dur="." if dur=="--"
replace ind="." if ind=="---"
replace occu="." if occu=="---"

drop if age>=0 & age<16 // dropping individuals not old enough to be in the labor force but keeping -1 missing observations

replace gemsa = 1 if gemsa > 0 
rename gemsa metropolitan

compress
save Data/cpsb`x'.dta, replace

local x = `x' + 1
if (`x'-13)/100 == int((`x'-13)/100) {
    local x = `x' + 88
    }
}

*

while `x' <=200404 {
clear
infix double gestfips 93-94 double hrhhid 1-15 double PRSJMJ 496-497 double PREMP 480-481 str hrsersuf 75-76 line 147-148 mis 63-64 age 122-123 race 139-140 sex 129-130 status 180-181 str dur 407-409 double fweight 613-622 double lweight 593-602 llind 69-70 educ 137-138 mar 125-126 str ind 856-859 str occu 860-863 /// 
	double HRINTSTA 57-58 HUTYPEA 41-42 HUTYPEB 43-44 HUTYPEC 45-46 double HUINTTYP 65-66 double LFPROXY 178-179 double employ_type 432-433 double non_farm 460-461 str HRSAMPLE 71-74 double HRSAMPLE_num 72-73 HUHHNUM 77-78 double PWCMPWGT 846-855 county 101-103 ind_recode 482-483 occu_recode 486-487 HETENURE 29-30 fam_income 39-40 gemsa 97-100 double PEHSPNON 157-158 PELKLWO 340-341 ///
using Data/cpsb`x'.raw

replace hrsersuf="0" if hrsersuf=="-1"
replace hrsersuf="1" if hrsersuf=="A"
replace hrsersuf="2" if hrsersuf=="B"
replace hrsersuf="3" if hrsersuf=="C"
replace hrsersuf="4" if hrsersuf=="D"
replace hrsersuf="5" if hrsersuf=="E"
replace hrsersuf="6" if hrsersuf=="F"
replace hrsersuf="7" if hrsersuf=="G"
replace hrsersuf="8" if hrsersuf=="H"
replace hrsersuf="9" if hrsersuf=="I"
replace hrsersuf="10" if hrsersuf=="J"
replace hrsersuf="11" if hrsersuf=="K"
replace hrsersuf="12" if hrsersuf=="L"
replace hrsersuf="13" if hrsersuf=="M"
replace hrsersuf="14" if hrsersuf=="N"
replace hrsersuf="15" if hrsersuf=="O"
replace hrsersuf="16" if hrsersuf=="P"
replace hrsersuf="17" if hrsersuf=="Q"
replace hrsersuf="18" if hrsersuf=="R"
replace hrsersuf="19" if hrsersuf=="S"
replace hrsersuf="20" if hrsersuf=="T"
replace hrsersuf="21" if hrsersuf=="U"
replace hrsersuf="22" if hrsersuf=="V"
replace hrsersuf="23" if hrsersuf=="W"
replace hrsersuf="24" if hrsersuf=="X"
replace hrsersuf="25" if hrsersuf=="Y"
replace hrsersuf="26" if hrsersuf=="Z" // changed X and Z to the more intuitive version
destring hrsersuf, replace

gen hrhhid2 = HRSAMPLE_num * 1000 + hrsersuf * 10 + HUHHNUM
gen hhid_unique = hrhhid * 100000 + hrhhid2 
drop HRSAMPLE HRSAMPLE_num hrsersuf HUHHNUM 

gen county1 = gestfips * 1000 + county 

replace dur="." if dur=="--"
replace ind="." if ind=="---"
replace occu="." if occu=="---"

drop if age>=0 & age<16 // dropping individuals not old enough to be in the labor force but keeping -1 missing observations

replace gemsa = 1 if gemsa > 0 
rename gemsa metropolitan

compress
save Data/cpsb`x'.dta, replace

local x = `x' + 1
if (`x'-13)/100 == int((`x'-13)/100) {
    local x = `x' + 88
    }
}

*

while `x' <=202107 {
clear
infix double gestfips 93-94 double hrhhid 1-15 hrhhid2 71-75 double PRSJMJ 496-497 double PREMP 480-481 hrsersuf 73-74 line 147-148 mis 63-64 age 122-123 race 139-140 sex 129-130 status 180-181 str dur 407-409 double fweight 613-622 double lweight 593-602 llind 69-70 educ 137-138 mar 125-126 str ind 856-859 str occu 860-863 ///
	double HRINTSTA 57-58 HUTYPEA 41-42 HUTYPEB 43-44 HUTYPEC 45-46 double HUINTTYP 65-66 double LFPROXY 178-179 double employ_type 432-433 double non_farm 460-461 str HRSAMPLE 71-72 double PWCMPWGT 846-855 county 101-103 ind_recode 482-483 occu_recode 486-487 HETENURE 29-30 fam_income 39-40 gemsa 96-100 double PEHSPNON 157-158 PELKLWO 340-341 ///
using Data/cpsb`x'.raw

gen hhid_unique = hrhhid * 100000 + hrhhid2 

gen county1 = gestfips * 1000 + county 

replace dur="." if dur=="--"
replace ind="." if ind=="---"
replace occu="." if occu=="---"

drop if age>=0 & age<16 // dropping individuals not old enough to be in the labor force but keeping -1 missing observations

replace gemsa = 1 if gemsa > 0 
rename gemsa metropolitan

compress
save Data/cpsb`x'.dta, replace

local x = `x' + 1
if (`x'-13)/100 == int((`x'-13)/100) {
    local x = `x' + 88
    }
}


