*** How Does the Dramatic Rise of CPS Nonresponse Impact Labor Market Indicators? 
*** Bernhardt, Munro, Wolcott 
*** Journal of Applied Econometrics 
*** 2023 

*** flows_and_corrections2.do

** Builds off of flows_and_corrections1.do 
** Executes Correactions in 2 Waves
** Take 1: Basic Flows Correction
** Take 2: Checks robustness of using partial responders flow rates instead of full sample 

cd "$IS_dir"
clear

*

** (a) Basic Flows Correction 

** Looks across all months Feb1998-Aug2020 
** Computes official (raw) labor force participation and unemployment rates 
** Compares official rates to corrected rates obtained from naive corrections & flows corrections 
** Limitations: only looks 1 month in either direction (doesn't match over mis 4-5 gap)
** Only corrects for type-A non-responders


global month = 199802 // Starts 1 month after so we can look backwards 
clear 
gen date = . 

while $month <= 202008 { // Ends 1 month before most recent so we can look forwards 

global month_prev = $month - 1 
global month_next = $month + 1 

if ($month_prev / 100) == int($month_prev / 100) { 
	global month_prev = $month_prev - 88 
	}

if ($month_next - 13) / 100 == int(($month_next - 13) / 100) {
	global month_next = $month_next + 88
	}

*** 
	
quietly do Stata-Code/Function-Scripts/flows2_flows_corr.do 

***

global month = $month + 1 
if ($month - 13)/100 == int(($month - 13)/100) {
    global month = $month + 88
	di int($month/100)-1 " Finished"
    }
}

* 

gen date_num = date - int(date/100)*100
replace date_num = date_num + int(date/100)*12 - 1998*12
gen mdate = m(1998m1) + date_num - 1
drop date_num 

tsset mdate, m 

save Data/labor_force_corrections.dta, replace 


