*** How Does the Dramatic Rise of CPS Nonresponse Impact Labor Market Indicators? 
*** Bernhardt, Munro, Wolcott 
*** Journal of Applied Econometrics 
*** 2023 

*** main.do 
*** Main Runner File 

global IS_dir : pwd
cd "$IS_dir"

set graphics off 
timer clear 
timer on 100  

** Extract Data 
quietly do "$IS_dir/Stata-Code/CPS_Extract.do"
di "Data Extraction Finished" 

** Aggregate Response Rates 
quietly do "$IS_dir/Stata-Code/aggregate_response_rates.do" 
di "Aggregate Response Rates Finished" 

** Month-in-Sample Separate Prepare 
quietly do "$IS_dir/Stata-Code/mis_separate_prepare.do"
di "MIS Separate Prepare Finished" 

** Eight-Panel Generate 
quietly do "$IS_dir/Stata-Code/eight_panel_generate.do"
di "Eight-Panel Generate Finished" 

** Eight-Panel Household Generate 
quietly do "$IS_dir/Stata-Code/eight_panel_generate_hh.do"
di "Eight-Panel Generate HH Finished"

** Generate time series of occupied share with/without adjdacent month response 	
quietly do "$IS_dir/Stata-Code/TimeSeriesPartial_vs_NeverResponse.do"
di "Regressions Time Series Partial vs. Never Finished" 

** Attrition & LF Status by Month
quietly do "$IS_dir/Stata-Code/Attrition and LF status by MIS.do"
di "Attrition & LF Status by Month Finished" 

** Flows and Corrections 1 
quietly do "$IS_dir/Stata-Code/flows_and_corrections1.do"
di "Flows and Corrections 1 Finished" 

** Flows and Corrections 2 
quietly do "$IS_dir/Stata-Code/flows_and_corrections2.do"
di "Flows and Corrections 2 Finished" 

** Flows and Corrections 3 
quietly do "$IS_dir/Stata-Code/flows_and_corrections3.do"
di "Flows and Corrections 3 Finished"

** Recreating BLS Weights
quietly do "$IS_dir/Stata-Code/Recreating_BLS_Weights.do"
di "Recreating BLS Weights Finished" 

** Flows Output Generation
quietly do "$IS_dir/Stata-Code/flows_output_generation.do"
di "Flows Output Generation Finished" 

clear 
set graphics on 
timer off 100 
timer list 

di "Main File Completed" 

